unit UDfmToTxt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, NlDlg32, ShellApi, ureport, ExtCtrls;

type

(*
  TDropTarget = class(TInterfacedObject, IDropTarget)
  private
    fText: string;
  protected
    function DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
        pt: TPoint; var dwEffect: Longint): HResult; stdcall;
    function DragOver(grfKeyState: Longint; pt: TPoint;
        var dwEffect: Longint): HResult; stdcall;
    function DragLeave: HResult; stdcall;
    function Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint;
        var dwEffect: Longint): HResult; stdcall;
  public
    property Text: string read fText write fText;
  end;
*)


  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormShow(Sender: TObject);
    function ConvertToText(Fn: String): Boolean;
    function ConvertToDfm(Fn: String): Boolean;
    procedure ConvertFile(Fn: String);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    //DropTarget1: TDropTarget;
    ErrorMsg: String;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

implementation

uses Errors;
{$R *.DFM}



procedure TForm1.FormCreate(Sender: TObject);
begin
  Left := 15;
  Top := 15;
end;

procedure TForm1.FormShow(Sender: TObject);
var i: Integer;
begin
  DragAcceptFiles(Handle, True);
  Label1.Width := ClientWidth - 4;
  Label2.Width := ClientWidth - 4;
  Label3.Width := ClientWidth - 4;
  Label4.Width := ClientWidth - 4;
  Label1.Left := 2;
  Label2.Left := 2;
  Label3.Left := 2;
  Label4.Left := 2;
  Label1.Caption := 'Pleur en sleur hier';
  Label2.Caption := 'Delphi 3 Form bestanden';
  Label3.Caption := 'voor conversie';
  Label4.Caption := 'DFM naar TXT en vice versa';
  for i := 1 to ParamCount do ConvertFile(ParamStr(i));
end;

procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
  NrOfFiles, i: Integer;
  S: String;
begin
  try
    NrOfFiles := DragQueryFile(Msg.Drop, $FFFFFFFF, CFileName, MAX_PATH);
    //W('NrOfFiles = '+IntToStr(NrOfFiles));
    for i := 0 to NrOfFiles - 1 do
    begin
      if DragQueryFile(Msg.Drop, i, CFileName, MAX_PATH) > 0 then
      begin
        ConvertFile(CFileName);
      end;
    end;
    Msg.Result := 0;
  finally
    DragFinish(Msg.Drop);
  end;
end;



function TForm1.ConvertToText(Fn: String): Boolean;
Var
  InputStream, OutputStream : TFileStream;
begin
  //Initialiseren op nil, anders Accesviolation bij Free als Create mislukt !!
  InputStream := nil;
  OutputStream := nil;
  try
    try
      { Create a file stream for the specified file }
      InputStream  := TFileStream.Create(Fn, fmOpenRead);
      OutputStream := TFileStream.Create(Fn + '.txt', fmCreate);
      { Now perform the selected conversion }
      ObjectResourceToText(InputStream, OutputStream);
      Result := True;
    Except
      On E: EStreamError do
      begin
        Result := False;
        ErrorMsg := 'Streaming fout: ' + E.Message;
      end;
    End ;
  Finally
    InputStream.Free;
    OutputStream.Free;
  End ;
end;

function TForm1.ConvertToDfm(Fn: String): Boolean;
Var
  InputStream, OutputStream : TFileStream;
begin
  //Initialiseren op nil, anders Accesviolation bij Free als Create mislukt !!
  Result := False;
  InputStream := nil;
  OutputStream := nil;
  try
    try
      { Create a file stream for the specified file }
      InputStream  := TFileStream.Create(Fn, fmOpenRead);
      OutputStream := TFileStream.Create(Fn + '.dfm', fmCreate);
      { Now perform the selected conversion }
      ObjectTextToResource(InputStream, OutputStream) ;
      Result := True;
    Except
      On E: EStreamError do
      begin
        Result := False;
        ErrorMsg := 'Streaming fout: ' + E.Message;
      end;
    End ;
  Finally
    InputStream.Free;
    OutputStream.Free;
  End ;
end;

procedure TForm1.ConvertFile(Fn: String);
var Result: Boolean;
begin
  ErrorMsg := '';
  if not FileExists(Fn) then
  begin
    ErrorMsg := 'Bestand niet gevonden';
    Result := false;
  end
  else if CompareText(ExtractFileExt(Fn),'.DFM') = 0 then
  begin
    Result := ConvertToText(Fn);
  end
  else if CompareText(ExtractFileExt(Fn),'.TXT') = 0 then
  begin
    Result := ConvertToDfm(Fn);
  end
  else
  begin
    Result := False;
    ErrorMsg := 'Bestand is geen Delphi From';
  end;
  With ReportForm do
  begin
    Application.BringToFront;
    Report(Fn,Result, ErrorMsg);
  end;
end;


end.
