unit ureport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TReportForm = class(TForm)
    Editor: TRichEdit;
    ClearBtn: TButton;
    CloseBtn: TButton;
    procedure ClearBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Report(Fn: String; Success: Boolean; const ErrorMsg: String);
  end;

var
  ReportForm: TReportForm;

implementation

{$R *.DFM}

procedure TReportForm.Report(Fn: String; Success: Boolean; const ErrorMsg: String);
begin
  if not ReportForm.Visible then Show;
  With Editor do
  begin
    SelAttributes.Color := DefAttributes.Color;
    SelText := Fn + ': ';
    if Success then
    begin
      SelAttributes.Color := clGreen;
      SelText := 'conversie geslaagd.'
    end
    else
    begin
      SelText := 'conversie ';
      SelAttributes.Color := clRed;
      SelText := 'niet';
      SelAttributes.Color := DefAttributes.Color;
      Seltext := ' geslaagd (';
      SelAttributes.Color := clRed;
      SelText := ErrorMsg;
      SelAttributes.Color := DefAttributes.Color;
      Seltext := ').';
    end;
    SelText := #13#10;
  end;
end;


procedure TReportForm.ClearBtnClick(Sender: TObject);
begin
  Editor.Lines.Clear;
end;

procedure TReportForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

end.
